<?php
/**
* TODO: generar documentación
*/
require_once("clases_gtk/zen_fabrica_gtk.php");
class zen_menu_gtk extends GtkMenuBar {
	var $xml;
	var $widgets = array();
	var $anadirEnganches = true;

	function __construct() {
		parent::__construct();
		$this->fabrica = zen_fabrica_gtk::obtenerFabrica();
	}

	function crear_desde_cadena($cadena) {
		$this->xml = DOMDocument::loadXML($cadena);
		$this->inicio_construir();
	}

	function crear_desde_xml($file) {
		$this->xml = DOMDocument::load($file);
		$this->inicio_construir();
	}

	function inicio_construir() {
		if ($this->xml->validate()) {
		 $nodos = $this->xml->documentElement->childNodes;
		 $this->construir($this, $nodos);
		} else {
		 throw new Exception("Formato del XML incorrecto.");
		//trigger_error("Formato del XML incorrecto.");
		}
	}

	function construir($obj, $nodos) {
		foreach ($nodos as $nodo) {
			if ($nodo->nodeType != 1)
			 continue;
			$ret = $this->construirItems($nodo);
			$obj->append($ret);
		}
	}

	function construirItems($nodo, $tipo = null) {
		$fabrica =& $this->fabrica;

		if (!$tipo)
		 $tipo = $nodo->nodeName;
		$id = $nodo->getAttribute("id");

		if ($tipo != "separador" && is_null($id)) {
		 throw new Exception("Item sin id");
		 //trigger_error("Item sin id");
		}

		$mostrar = $nodo->getAttribute("mostrar");
		$icono = $nodo->getAttribute("icono");
		$enganche = $nodo->getAttribute("arrancable") == "true";

		switch ($tipo) {
			case "item":
				if (!is_null($mostrar)) {
					if (!is_null($icono)) {
						$item = $fabrica->imagen_menuItem($mostrar);
						$imagen = $fabrica->icono($icono);
						$item->set_image($imagen);
					} else {
						$item = $fabrica->menuItem($mostrar);
					}
				} else if (!is_null($icono)) {
					$item = $fabrica->imagen_menuItem($icono);
				} else {
				 //trigger_error("Cada item debe tener al menos un icono o un texto para mostrar");
					throw new Exception("Cada item debe tener al menos un icono o un texto para mostrar");
				}
				$this->registrar($id, $item);
				return $item;

			case "separador":
				return $fabrica->separadorItem();

			default:
				$menu = $fabrica->menu();
				if ($enganche && $this->anadirEnganches)
					$menu->append($fabrica->enganche());
				$this->construir($menu, $nodo->childNodes);

				$item = $this->construirItems($nodo, "item");
				$item->set_submenu($menu);

				return $item;
		}
	}

	function registrar($id, $obj) {
		if (!array_key_exists($id, $this->widgets))
		 $this->widgets[$id] = $obj;
		else
		 //trigger_error("Ya hay un widget con ese ID");
		 throw new Exception("Ya hay un widget con ese ID");
	}

	function obtenerWidget($id) {
		if (array_key_exists($id, $this->widgets))
		 return $this->widgets[$id];
		else return null;
	}

	function anadirEnganches($add) {
		$this->anadirEnganches = $add;
	}
}
?>
